
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AnnouncementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const announcements = await db.announcements.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        message: data.message
        ||
        null
            ,
            
        audience: data.audience
        ||
        null
            ,
            
        publish_datetime: data.publish_datetime
        ||
        null
            ,
            
        expire_datetime: data.expire_datetime
        ||
        null
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await announcements.setCamp_session( data.camp_session || null, {
            transaction,
        });
        

        

        

        return announcements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const announcementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                message: item.message
            ||
            null
            ,
            
                audience: item.audience
            ||
            null
            ,
            
                publish_datetime: item.publish_datetime
            ||
            null
            ,
            
                expire_datetime: item.expire_datetime
            ||
            null
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const announcements = await db.announcements.bulkCreate(announcementsData, { transaction });

        // For each item created, replace relation files
        

        return announcements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const announcements = await db.announcements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.message !== undefined) updatePayload.message = data.message;
        
        
        if (data.audience !== undefined) updatePayload.audience = data.audience;
        
        
        if (data.publish_datetime !== undefined) updatePayload.publish_datetime = data.publish_datetime;
        
        
        if (data.expire_datetime !== undefined) updatePayload.expire_datetime = data.expire_datetime;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        updatePayload.updatedById = currentUser.id;

        await announcements.update(updatePayload, {transaction});

        
        
        if (data.camp_session !== undefined) {
            await announcements.setCamp_session(
              
              data.camp_session,
              
              { transaction }
            );
        }
        

        
        

        

        return announcements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const announcements = await db.announcements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of announcements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of announcements) {
                await record.destroy({transaction});
            }
        });


        return announcements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const announcements = await db.announcements.findByPk(id, options);

        await announcements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await announcements.destroy({
            transaction
        });

        return announcements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const announcements = await db.announcements.findOne(
            { where },
            { transaction },
        );

        if (!announcements) {
            return announcements;
        }

        const output = announcements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.camp_session = await announcements.getCamp_session({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.camp_sessions,
        as: 'camp_session',
        
        where: filter.camp_session ? {
          [Op.or]: [
            { id: { [Op.in]: filter.camp_session.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.camp_session.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'announcements',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'announcements',
                        'message',
                        filter.message,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            publish_datetime: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    expire_datetime: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.publish_datetimeRange) {
                const [start, end] = filter.publish_datetimeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    publish_datetime: {
                    ...where.publish_datetime,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    publish_datetime: {
                    ...where.publish_datetime,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expire_datetimeRange) {
                const [start, end] = filter.expire_datetimeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expire_datetime: {
                    ...where.expire_datetime,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expire_datetime: {
                    ...where.expire_datetime,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.audience) {
                where = {
                    ...where,
                audience: filter.audience,
            };
            }
            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.announcements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'announcements',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.announcements.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

